from http import HTTPStatus
from typing import Any
from urllib.parse import quote

import httpx

from ... import errors
from ...client import AuthenticatedClient, Client
from ...models.cws_error_dto import CwsErrorDTO
from ...models.order import Order
from ...types import Response


def _get_kwargs(
    customer_ekp: str,
    order_id: str,
    *,
    authorization: str = "Bearer [place  OAuth access_token here, without brackets]",
) -> dict[str, Any]:
    headers: dict[str, Any] = {}
    headers["Authorization"] = authorization

    _kwargs: dict[str, Any] = {
        "method": "get",
        "url": "/dpi/shipping/v1/bulk/{customer_ekp}/orders/{order_id}".format(
            customer_ekp=quote(str(customer_ekp), safe=""),
            order_id=quote(str(order_id), safe=""),
        ),
    }

    _kwargs["headers"] = headers
    return _kwargs


def _parse_response(*, client: AuthenticatedClient | Client, response: httpx.Response) -> CwsErrorDTO | Order | None:
    if response.status_code == 200:
        response_200 = Order.from_dict(response.json())

        return response_200

    if response.status_code == 403:
        response_403 = CwsErrorDTO.from_dict(response.json())

        return response_403

    if response.status_code == 404:
        response_404 = CwsErrorDTO.from_dict(response.json())

        return response_404

    if response.status_code == 500:
        response_500 = CwsErrorDTO.from_dict(response.json())

        return response_500

    if client.raise_on_unexpected_status:
        raise errors.UnexpectedStatus(response.status_code, response.content)
    else:
        return None


def _build_response(*, client: AuthenticatedClient | Client, response: httpx.Response) -> Response[CwsErrorDTO | Order]:
    return Response(
        status_code=HTTPStatus(response.status_code),
        content=response.content,
        headers=response.headers,
        parsed=_parse_response(client=client, response=response),
    )


def sync_detailed(
    customer_ekp: str,
    order_id: str,
    *,
    client: AuthenticatedClient | Client,
    authorization: str = "Bearer [place  OAuth access_token here, without brackets]",
) -> Response[CwsErrorDTO | Order]:
    """Get a Bulk Order

     Searches the order for the given orderId.

    Args:
        customer_ekp (str):
        order_id (str):
        authorization (str):  Default: 'Bearer [place  OAuth access_token here, without
            brackets]'.

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Response[CwsErrorDTO | Order]
    """

    kwargs = _get_kwargs(
        customer_ekp=customer_ekp,
        order_id=order_id,
        authorization=authorization,
    )

    response = client.get_httpx_client().request(
        **kwargs,
    )

    return _build_response(client=client, response=response)


def sync(
    customer_ekp: str,
    order_id: str,
    *,
    client: AuthenticatedClient | Client,
    authorization: str = "Bearer [place  OAuth access_token here, without brackets]",
) -> CwsErrorDTO | Order | None:
    """Get a Bulk Order

     Searches the order for the given orderId.

    Args:
        customer_ekp (str):
        order_id (str):
        authorization (str):  Default: 'Bearer [place  OAuth access_token here, without
            brackets]'.

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        CwsErrorDTO | Order
    """

    return sync_detailed(
        customer_ekp=customer_ekp,
        order_id=order_id,
        client=client,
        authorization=authorization,
    ).parsed


async def asyncio_detailed(
    customer_ekp: str,
    order_id: str,
    *,
    client: AuthenticatedClient | Client,
    authorization: str = "Bearer [place  OAuth access_token here, without brackets]",
) -> Response[CwsErrorDTO | Order]:
    """Get a Bulk Order

     Searches the order for the given orderId.

    Args:
        customer_ekp (str):
        order_id (str):
        authorization (str):  Default: 'Bearer [place  OAuth access_token here, without
            brackets]'.

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Response[CwsErrorDTO | Order]
    """

    kwargs = _get_kwargs(
        customer_ekp=customer_ekp,
        order_id=order_id,
        authorization=authorization,
    )

    response = await client.get_async_httpx_client().request(**kwargs)

    return _build_response(client=client, response=response)


async def asyncio(
    customer_ekp: str,
    order_id: str,
    *,
    client: AuthenticatedClient | Client,
    authorization: str = "Bearer [place  OAuth access_token here, without brackets]",
) -> CwsErrorDTO | Order | None:
    """Get a Bulk Order

     Searches the order for the given orderId.

    Args:
        customer_ekp (str):
        order_id (str):
        authorization (str):  Default: 'Bearer [place  OAuth access_token here, without
            brackets]'.

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        CwsErrorDTO | Order
    """

    return (
        await asyncio_detailed(
            customer_ekp=customer_ekp,
            order_id=order_id,
            client=client,
            authorization=authorization,
        )
    ).parsed
